routes/web.php
<?php

use App\Http\Controllers\Admin\AdminPagesController;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\Admin\PhotosController as AdminPhotosController;
use App\Http\Controllers\Admin\CommentsController as AdminCommentsController;
use App\Http\Controllers\Admin\UsersController as AdminUsersController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::middleware('language')->group(function () {
    Route::get('/', [App\Http\Controllers\PhotosController::class, 'index'])->name('home');

    Route::resource('photos', \App\Http\Controllers\PhotosController::class)->except(['edit', 'update']);

    Route::resource('users', \App\Http\Controllers\UsersController::class)->only(['show', 'edit', 'update']);

    Route::resource('photos.comments', App\Http\Controllers\PhotosCommentsController::class)
        ->only(['store'])->middleware('auth');

    Auth::routes();
});

Route::prefix('admin')->middleware('auth')->name('admin.')->group(function () {
    Route::resources(
        [
            'photos' => AdminPhotosController::class,
            'comments' => AdminCommentsController::class,
            'users' => AdminUsersController::class
        ]
    );
    Route::get('dashboard', [AdminPagesController::class, 'index'])->middleware('auth')->name('dashboard');
});

Route::get('language/{locale}', [App\Http\Controllers\LanguageSwitcherController::class, 'switcher'])
    ->name('language.switcher')->where('locale', 'en|ru');

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable
{
    use HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    /**
     * @return HasMany
     */
    public function photos(): HasMany
    {
        return $this->hasMany(Photo::class);
    }

    /**
     * @return HasMany
     */
    public function comments(): HasMany
    {
        return $this->hasMany(Comment::class);
    }
}

app/Http/Controllers/Admin/UsersController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\User;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class UsersController extends Controller
{

    /**
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Contracts\View\View
     * @throws \Illuminate\Auth\Access\AuthorizationException
     */
    public function index()
    {
        $this->authorize('view', Auth::user());
        $users = User::all();
        return view('admin.users.index', compact('users'));
    }


    /**
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Contracts\View\View
     * @throws \Illuminate\Auth\Access\AuthorizationException
     */
    public function create()
    {
        $this->authorize('view', Auth::user());
        return view('admin.users.create');
    }


    /**
     * @param Request $request
     * @return \Illuminate\Http\RedirectResponse
     * @throws \Illuminate\Auth\Access\AuthorizationException
     */
    public function store(Request $request): RedirectResponse
    {
        $this->authorize('view', Auth::user());
        $user = new User($request->all());
        $user->save();

        return redirect()->route('admin.users.index');
    }


    /**
     * @param User $user
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Contracts\View\View
     * @throws \Illuminate\Auth\Access\AuthorizationException
     */
    public function show(User $user)
    {
        $this->authorize('view', Auth::user());
        return view('admin.users.show', compact('user'));
    }


    /**
     * @param User $user
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Contracts\View\View
     */
    public function edit(User $user)
    {
        return view('admin.users.edit', compact('user'));
    }


    /**
     * @param Request $request
     * @param User $user
     * @return RedirectResponse
     * @throws \Illuminate\Auth\Access\AuthorizationException
     */
    public function update(Request $request, User $user): RedirectResponse
    {
        $this->authorize('view', Auth::user());
        $user->update($request->all());
        return redirect()->action([self::class, 'show'], ['user' => $user]);
    }


    /**
     * @param User $user
     * @return \Illuminate\Http\RedirectResponse
     * @throws \Illuminate\Auth\Access\AuthorizationException
     */
    public function destroy(User $user)
    {
        $this->authorize('view', Auth::user());
        $user->delete();
        return redirect()->route('admin.users.index', $user->user_id);
    }
}

app/Http/Controllers/Api/UsersController.php
<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use App\Http\Resources\UserResource;
use App\Models\User;
use Illuminate\Http\Request;

class UsersController extends Controller
{

    /**
     * @return \Illuminate\Http\Resources\Json\AnonymousResourceCollection
     */
    public function index()
    {
        $users = User::all();
        return UserResource::collection($users);
    }
}

app/Http/Controllers/UsersController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\UserRequest;
use App\Models\User;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;

class UsersController extends Controller
{

    /**
     * @param User $user
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Contracts\View\View
     */
    public function show(User $user)
    {
        return view('users.show', compact('user'));
    }


    /**
     * @param User $user
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Contracts\View\View
     */
    public function edit(User $user)
    {
        return view('users.edit', compact('user'));
    }


    /**
     * @param UserRequest $request
     * @param User $user
     * @return RedirectResponse
     * @throws \Illuminate\Auth\Access\AuthorizationException
     */
    public function update(UserRequest $request, User $user): RedirectResponse
    {
        $this->authorize('update', $user);
        $user->update($request->all());
        return redirect()->route('users.show', compact('user'));
    }
}

resources/views/users/edit.blade.php
@extends('layouts.app')

@section('content')

    <div class="col main pt-5 mt-3">
        <h1>@lang('messages.edit')</h1>
        <form enctype="multipart/form-data" method="post" action="{{ route('users.update', ['user' => $user]) }}">
            @method('put')
            @csrf
            <div class="form-group">
                <label for="name"><b>@lang('messages.name')</b></label>
                <input type="text" class="form-control" id="name" name="name" value="{{$user->name}}">
                @if ($errors->has('name'))
                    <div class="alert alert-danger">
                        <ul>
                            @error('name')
                            <li>@lang('messages.error')</li>
                            @enderror
                        </ul>
                    </div>
                @endif
            </div>
            <button type="submit" class="btn btn-primary">@lang('messages.submit')</button>
        </form>
    </div>

@endsection

resources/views/users/show.blade.php
@extends('layouts.app')

@section('content')

    <div class="container">
        <div class="card-body">
            <h3>{{$user->name}}</h3>
        </div>

        @can('update', $user)
            @if (Auth::user()->id == $user->id)
                    <a href="{{route('users.edit', ['user' => $user])}}" class="btn btn-primary"><b>@lang('messages.edit')</b></a>
            @endif
        @endcan

        @can('create', \App\Models\Photo::class)
            @if (Auth::user()->id == $user->id)
                    <a href="{{route('photos.create')}}" class="btn btn-primary"><b>@lang('messages.add_photo')</b></a>
            @endif
        @endcan

        <div class="card-body">
            <a href="{{route('photos.index')}}" class="btn btn-primary"><b>@lang('messages.back')</b></a>
        </div>

        <div class="row row-cols-1 row-cols-md-2 row-cols-lg-3 justify-content-center">
            @foreach($user->photos as $photo)
                <div class="d-flex col mb-3">
                    <div class="card" style="width: 16rem">
                        <div class="card-img">
                            <img src="{{asset('/storage/' . $photo->photo)}}" class="card-img-top" alt="{{$photo->photo}}">
                        </div>
                        <div class="card-body d-flex flex-column">
                            <h5 class="card-title"><b>{{$photo->title}}</b></h5>
                            <div class="mt-auto">
                                <a href="{{route('photos.show', ['photo' => $photo])}}" class="btn btn-primary"><b>@lang('messages.show')</b></a>
                                <div class="d-inline-block">
                                    @can('delete', $photo)
                                        <form method="post" action="{{route('photos.destroy', ['photo' => $photo])}}">
                                            @method('delete')
                                            @csrf
                                            <button type="submit" class="btn btn-primary"><b>@lang('messages.delete')</b></button>
                                        </form>
                                    @endcan
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            @endforeach
        </div>
    </div>

@endsection